@if (@$)==(@_) goto bat @end/*
@echo off

:: check interpreter
if not n^t==nt goto :eof
set ~x9=
if "%~x9%~x9"=="~x9" setlocal enableextensions
if "%~x9%~x9"=="~x9" goto :eof
if not cmdextversion 2 exit/b
if "!~x9!~x9"=="~x9" ( setlocal disabledelayedexpansion
if "!~x9!~x9"=="~x9" exit/b
) else setlocal
if not defined TEMP exit/b
call& >nul set TEMP && if errorlevel 1 exit/b
if not defined COMSPEC exit/b
if not defined USERPROFILE exit/b
2>nul set CD && exit/b || if not defined CD exit/b
2>nul set DATE && exit/b || if not defined DATE exit/b
2>nul set TIME && exit/b || if not defined TIME exit/b
2>nul set RANDOM && exit/b || if not defined RANDOM exit/b
2>nul set ERRORLEVEL && exit/b || if not defined ERRORLEVEL exit/b
2>nul set CMDCMDLINE && exit/b || if not defined CMDCMDLINE exit/b

:: assume launch context
set ""=""
if not defined ^" echo on & prompt;::$S$T$_

:: syntactic sugar
set "^=(:)^
set "&&=||:&if;not;errorlevel;1;
set "||=||:&if;errorlevel;1;
set "if=call;&(if
set "or=call)&&(if
set "and=if
set "then=call)&if;errorlevel;1

:: check arguments
if not "%~1"=="" goto end

:: check executables and paths
if not exist "_setup\*" goto err
if not exist "_setup\_tools\md5\md5.exe" goto err
if not exist "_setup\_tools\finesplit\trial\finesplit.exe" goto err
if not exist "_setup\_tools\finesplit\update\finesplit.exe" goto err
if not exist "_setup\_tools\stix\STIX_W.EXE" goto err
if not exist "_setup\_tools\bsdiff\bspatc'h.exe" goto err
if not exist "_setup\_tools\bsdiff\patch\*.patch" goto err
if not exist "_setup\_files\patch\*" goto err
if not exist "_setup\_files\upnpc\upnpc-static.exe" goto err
if "%CD:~-1%"=="\" goto loc
if "%CD:~1,1%"=="\" goto loc
if not exist "%~nx0" goto loc

:: =======================================================================================

:: check current install state
echo SimCity 2000 Network Edition
echo Interoperability Patch - 1.5
if not exist "2knet\*"            call :wel "%~nx0"
if not exist "2knet\2KCLIENT.EXE" call :ins "%~nx0"
if not exist "2knet\2KSERVER.EXE" call :ins "%~nx0"
if not exist "2knet\MAXHELP.EXE"  call :ins "%~nx0"
if not exist "2knet\COST.DB"      call :ins "%~nx0"
if not exist "2knet\HOSTILES.DB"  call :ins "%~nx0"
if not exist "2knet\TILES.DB"     call :ins "%~nx0"
if not exist "2knet\SC2K.PAL"     call :ins "%~nx0"
if not exist "2knet\docs\*"       call :ins "%~nx0"
if not exist "2knet\html\*"       call :ins "%~nx0"
if not exist "2knet\sounds\*"     call :ins "%~nx0"
if not exist "2knet\USARES.DLL"   call :upd "%~nx0"
if not exist "2knet\USAHORES.DLL" call :upd "%~nx0"
if not exist "2knet\WEBSTER.OCX"  call :ocx "%~nx0"
if not exist "2knet\portable.dll" call :new "%~nx0"
if exist "2knet\WINSCURK.EXE" ^
_setup\_tools\md5\md5.exe -cC5AC16701CFE62DE87103BF4F4E74248 "2knet\WINSCURK.EXE" || call :p_0 "%~nx0"
_setup\_tools\md5\md5.exe -c6DEB7E19030CDE50FBD5BA0AAE699FE4 "2knet\2KCLIENT.EXE" || call :p_1 "%~nx0"
_setup\_tools\md5\md5.exe -cF5E61FC87EA2023B55D7456E694F5D25 "2knet\2KSERVER.EXE" || call :p_2 "%~nx0"
_setup\_tools\md5\md5.exe -cF4139EC4ECAEEF79E219AFB9F41BB90D "2knet\USARES.DLL"   || call :p_3 "%~nx0"
_setup\_tools\md5\md5.exe -c865FCD4BDA8341B978C3701BE9E0A6F7 "2knet\USAHORES.DLL" || call :p_4 "%~nx0"
_setup\_tools\md5\md5.exe -c5119465EFFC9DEAA02CA1899A0F8F4AA "2knet\MAXHELP.EXE"  || call :p_5 "%~nx0"
%if% not exist "host.cmd" %or% not exist "play.cmd" %then% %^%
(
	call :tut "%~nx0"
)^
else %^%
(
	echo;
	echo All files successfully validated
)
goto end

:: .......................................................................................

:wel
echo;
echo Welcome to the automated SimCity 2000 Network Edition
echo Interoperability Patch Setup Script (IPSS for short).
echo;
echo The IPSS can download the SimCity 2000 Network Edition trial version and
echo official version 1.1 update automatically, or you can answer "no" to the
echo download prompt and download the necessary files manually.
echo;
echo Lucky owners of the retail version of SimCity 2000 Network Edition can simply
echo copy the 2KNET folder from their install CD into this folder alongside the
echo IPSS script before continuing instead of downloading the trial version.
echo;
pause
echo;
echo ...
if not exist "2knet\*" mkdir "2knet"
goto :eof

:: .......................................................................................

:tut
if not exist "host.cmd" copy /y _setup\_files\patch\host.cmd .>nul
if not exist "play.cmd" copy /y _setup\_files\patch\play.cmd .>nul
echo;
echo Setup completed successfully
echo;
echo ...
echo;
echo If you'd like to host a game to play with friends, simply run host.cmd; if
echo your router supports UPnP, port forwarding will occur automatically and a
echo command prompt will tell you your public IP address. After starting the server,
echo run play.cmd, click the "Join Game" button, and enter 127.0.0.1 as the IP
echo address when prompted.
echo;
echo If your router doesn't support UPnP, you'll need to manually forward port 2586.
echo;
echo To play alone, go to the 2KNET subfolder and run 2KSERVER.EXE, select
echo File -^> Start New Game from the menu, then run 2KCLIENT.EXE, click the
echo "Join Game" button, and enter 127.0.0.1 as the IP address when prompted.
echo;
echo To join a friend's game, simply run play.cmd, click the "Join Game" button, and
echo enter their IP address when prompted.
goto :eof

:: .......................................................................................

:ins
if not exist "_setup\SETUP2K.EXE" %^%
(
	echo;
	echo Cannot find _setup\SETUP2K.EXE
	echo;
	echo Download it now? [y/n]
	set]=n&set/p]=&set]|find/i"]=y">nul
	if not errorlevel 1 call :i_1 "%~1"
if not exist "_setup\SETUP2K.EXE" %^%
(
	echo;
	echo View website with download link for 2knetdem.zip? [y/n]
	set]=y&set/p]=&set]|find/i"]=y">nul
	if errorlevel 1 goto brk
	start "" "http://download.exdat.com/download/simcity_2000_network_edition-8700/2knetdem.zip"
	start "" explorer.exe /e,.\_setup
	echo;
	echo After downloading, manually unzip 2knetdem.zip and move or copy
	echo SETUP2K.EXE into the _setup folder
	echo;
	pause
	goto ins
)
)
_setup\_tools\md5\md5.exe -c82A4877995C990701A47D6A29DA106CC "_setup\SETUP2K.EXE" || %^%
(
	echo;
	echo _setup\SETUP2K.EXE MD5 checksum failure
	echo;
	echo Reacquire? [y/n]
	set]=y&set/p]=&set]|find/i"]=y">nul
	if errorlevel 1 goto brk
	del _setup\SETUP2K.EXE
	goto ins
)
%if% not exist "_setup\SETUP2K.EXE.01" %or% not exist "_setup\SETUP2K.EXE.03" %then% %^%
(
	echo;
	echo Removing obsolete 16-bit trial installer stub
	_setup\_tools\finesplit\trial\finesplit.exe _setup\SETUP2K.EXE
	del _setup\SETUP2K.EXE.00
	del _setup\SETUP2K.EXE.02
	del _setup\SETUP2K.EXE.bat
)
if not exist "_setup\_files\trial\*" %^%
(
	echo;
	echo Extracting trial installer contents
	_setup\_tools\stix\STIX_W.EXE _setup\SETUP2K.EXE.01 _setup\_files\trial>nul
	_setup\_tools\stix\STIX_W.EXE _setup\SETUP2K.EXE.03 _setup\_files\trial\shared>nul
)
	echo;
	echo Copying trial installer contents
(
	copy /y _setup\_files\trial\2KCLIENT.EXE 2knet
	copy /y _setup\_files\trial\2KSERVER.EXE 2knet
	copy /y _setup\_files\trial\MAXHELP.EXE 2knet
	copy /y _setup\_files\trial\COST.DB 2knet
	copy /y _setup\_files\trial\HOSTILES.DB 2knet
	copy /y _setup\_files\trial\TILES.DB 2knet
	copy /y _setup\_files\trial\SC2K.PAL 2knet
	xcopy /e /i /q /h /k /y _setup\_files\trial\docs 2knet\docs
	xcopy /e /i /q /h /k /y _setup\_files\trial\html 2knet\html
	xcopy /e /i /q /h /k /y _setup\_files\trial\sounds 2knet\sounds
)>nul
goto :eof

:: .......................................................................................

:upd
if not exist "_setup\Update2KNet11.exe" %^%
(
	echo;
	echo Cannot find _setup\Update2KNet11.exe
	echo;
	echo Download it now? [y/n]
	set]=n&set/p]=&set]|find/i"]=y">nul
	if not errorlevel 1 call :i_2 "%~1"
if not exist "_setup\Update2KNet11.exe" %^%
(
	echo;
	echo View website with download links? [y/n]
	set]=y&set/p]=&set]|find/i"]=y">nul
	if errorlevel 1 goto brk
	start "" "http://www.filewatcher.com/m/update2knet11.exe.2061538-0.html"
	start "" explorer.exe /e,.\_setup
	echo;
	echo After downloading, manually move or copy
	echo Update2KNet11.exe into the _setup folder
	echo;
	pause
	goto upd
)
)
_setup\_tools\md5\md5.exe -c2C3CCAC00E8410D73CBEA858B9D25159 "_setup\Update2KNet11.exe" || %^%
(
	echo;
	echo _setup\Update2KNet11.exe MD5 checksum failure
	echo;
	echo Reacquire? [y/n]
	set]=y&set/p]=&set]|find/i"]=y">nul
	if errorlevel 1 goto brk
	del _setup\Update2KNet11.exe
	goto upd
)
if not exist "_setup\Update2KNet11.exe.01" %^%
(
	echo;
	echo Removing obsolete 16-bit update installer stub
	_setup\_tools\finesplit\update\finesplit.exe _setup\Update2KNet11.exe
	del _setup\Update2KNet11.exe.00
	del _setup\Update2KNet11.exe.bat
)
if not exist "_setup\_files\update\*" %^%
(
	echo;
	echo Extracting update installer contents
	_setup\_tools\stix\STIX_W.EXE _setup\Update2KNet11.exe.01 _setup\_files\update>nul
)
	echo;
	echo Copying update installer contents
(
	copy /y _setup\_files\update\2KCLIENT.EXE 2knet
	copy /y _setup\_files\update\2KSERVER.EXE 2knet
	copy /y _setup\_files\update\USARES.DLL 2knet
	copy /y _setup\_files\update\USAHORES.DLL 2knet
)>nul
goto :eof

:: .......................................................................................

:ocx
if not exist "2knet\shared\WEBSTER.OCX" %^%
(
if not exist "_setup\SETUP2K.EXE" %^%
(
	echo;
	echo Cannot find _setup\SETUP2K.EXE
	echo;
	echo Download it now? [y/n]
	set]=n&set/p]=&set]|find/i"]=y">nul
	if not errorlevel 1 call :i_1 "%~1"
if not exist "_setup\SETUP2K.EXE" %^%
(
	echo;
	echo View website with download link for 2knetdem.zip? [y/n]
	set]=y&set/p]=&set]|find/i"]=y">nul
	if errorlevel 1 goto brk
	start "" "http://download.exdat.com/download/simcity_2000_network_edition-8700/2knetdem.zip"
	start "" explorer.exe /e,.\_setup
	echo;
	echo After downloading, manually unzip 2knetdem.zip and move or copy
	echo SETUP2K.EXE into the _setup folder
	echo;
	pause
	goto ocx
)
)
_setup\_tools\md5\md5.exe -c82A4877995C990701A47D6A29DA106CC "_setup\SETUP2K.EXE" || %^%
(
	echo;
	echo _setup\SETUP2K.EXE MD5 checksum failure
	echo;
	echo Reacquire? [y/n]
	set]=y&set/p]=&set]|find/i"]=y">nul
	if errorlevel 1 goto brk
	del _setup\SETUP2K.EXE
	goto ocx
)
if not exist "_setup\SETUP2K.EXE.03" %^%
(
	echo;
	echo Removing obsolete 16-bit trial installer stub
	_setup\_tools\finesplit\trial\finesplit.exe _setup\SETUP2K.EXE
	del _setup\SETUP2K.EXE.00
	del _setup\SETUP2K.EXE.02
	del _setup\SETUP2K.EXE.bat
)
if not exist "_setup\_files\trial\shared\*" %^%
(
	echo;
	echo Extracting trial installer contents
	_setup\_tools\stix\STIX_W.EXE _setup\SETUP2K.EXE.01 _setup\_files\trial>nul
	_setup\_tools\stix\STIX_W.EXE _setup\SETUP2K.EXE.03 _setup\_files\trial\shared>nul
)
	echo;
	echo Copying COM dependency
>nul	copy /y _setup\_files\trial\shared\WEBSTER.OCX 2knet
)^
else %^%
(
	echo;
	echo Copying COM dependency
>nul	copy /y 2knet\shared\WEBSTER.OCX 2knet
)
goto :eof

:: .......................................................................................

:new
	echo;
	echo Copying interoperability files
(
	copy /y _setup\_files\patch\portable.dll 2knet
	copy /y _setup\_files\patch\dplay.dll 2knet
	copy /y _setup\_files\patch\*.manifest 2knet
	copy /y _setup\_files\patch\*.bat 2knet
	xcopy /e /i /q /h /k /y _setup\_files\upnpc 2knet\upnpc
)>nul
if not exist "2knet\INTRO.off.AVI" if exist "2knet\INTRO.AVI" %^%
(
	ren 2knet\INTRO.AVI INTRO.off.AVI
)
if not exist "2knet\sounds\517.off.WAV" %^%
(
	ren 2knet\sounds\517.WAV 517.off.WAV
>nul	copy /y 2knet\sounds\530.WAV 2knet\sounds\517.WAV
)
if not exist "2knet\sounds\518.off.WAV" %^%
(
	ren 2knet\sounds\518.WAV 518.off.WAV
>nul	copy /y 2knet\sounds\530.WAV 2knet\sounds\518.WAV
)
if not exist "2knet\sounds\519.off.WAV" %^%
(
	ren 2knet\sounds\519.WAV 519.off.WAV
>nul	copy /y 2knet\sounds\530.WAV 2knet\sounds\519.WAV
)
if not exist "2knet\sounds\524.off.WAV" %^%
(
	ren 2knet\sounds\524.WAV 524.off.WAV
>nul	copy /y 2knet\sounds\530.WAV 2knet\sounds\524.WAV
)
goto :eof

:: .......................................................................................

:: WINSCURK.EXE
:p_0
_setup\_tools\md5\md5.exe -c4E74E05ACA5B7F73E2E91B4222E397DF "2knet\WINSCURK.EXE" && %^%
(
	echo;
	echo Patching 2knet\WINSCURK.EXE
	ren 2knet\WINSCURK.EXE WINSCURK.EXE.old
	_setup\_tools\bsdiff\bspatc'h.exe 2knet\WINSCURK.EXE.old 2knet\WINSCURK.EXE _setup\_tools\bsdiff\patch\WINSCURK.EXE.patch
)
goto :eof

:: 2KCLIENT.EXE
:p_1
_setup\_tools\md5\md5.exe -c9942B057F14FA995CFE8D710E6C1B9BF "2knet\2KCLIENT.EXE" || %^%
(
>nul	copy /y _setup\_files\update\2KCLIENT.EXE 2knet
)
	echo;
	echo Patching 2knet\2KCLIENT.EXE
	ren 2knet\2KCLIENT.EXE 2KCLIENT.EXE.old
	_setup\_tools\bsdiff\bspatc'h.exe 2knet\2KCLIENT.EXE.old 2knet\2KCLIENT.EXE _setup\_tools\bsdiff\patch\2KCLIENT.EXE.patch
	del 2knet\2KCLIENT.EXE.old
goto :eof

:: 2KSERVER.EXE
:p_2
_setup\_tools\md5\md5.exe -c6C412CF27726879AAA97D75DB857A601 "2knet\2KSERVER.EXE" || %^%
(
>nul	copy /y _setup\_files\update\2KSERVER.EXE 2knet
)
	echo;
	echo Patching 2knet\2KSERVER.EXE
	ren 2knet\2KSERVER.EXE 2KSERVER.EXE.old
	_setup\_tools\bsdiff\bspatc'h.exe 2knet\2KSERVER.EXE.old 2knet\2KSERVER.EXE _setup\_tools\bsdiff\patch\2KSERVER.EXE.patch
	del 2knet\2KSERVER.EXE.old
goto :eof

:: USARES.DLL
:p_3
_setup\_tools\md5\md5.exe -c05B105B841E3FE34FE7F37CAE67B6D74 "2knet\USARES.DLL" || %^%
(
>nul	copy /y _setup\_files\update\USARES.DLL 2knet
)
	echo;
	echo Patching 2knet\USARES.DLL
	ren 2knet\USARES.DLL USARES.DLL.old
	_setup\_tools\bsdiff\bspatc'h.exe 2knet\USARES.DLL.old 2knet\USARES.DLL _setup\_tools\bsdiff\patch\USARES.DLL.patch
	del 2knet\USARES.DLL.old
goto :eof

:: USAHORES.DLL
:p_4
_setup\_tools\md5\md5.exe -cA3CF6380BF74DF2E8E266122F3BFA276 "2knet\USAHORES.DLL" || %^%
(
>nul	copy /y _setup\_files\update\USAHORES.DLL 2knet
)
	echo;
	echo Patching 2knet\USAHORES.DLL
	ren 2knet\USAHORES.DLL USAHORES.DLL.old
	_setup\_tools\bsdiff\bspatc'h.exe 2knet\USAHORES.DLL.old 2knet\USAHORES.DLL _setup\_tools\bsdiff\patch\USAHORES.DLL.patch
	del 2knet\USAHORES.DLL.old
goto :eof

:: MAXHELP.EXE
:p_5
_setup\_tools\md5\md5.exe -c4966A5EA9D79518241DD587F0E0BD135 "2knet\MAXHELP.EXE" || %^%
(
>nul	copy /y _setup\_files\trial\MAXHELP.EXE 2knet
)
	echo;
	echo Patching 2knet\MAXHELP.EXE
	ren 2knet\MAXHELP.EXE MAXHELP.EXE.old
	_setup\_tools\bsdiff\bspatc'h.exe 2knet\MAXHELP.EXE.old 2knet\MAXHELP.EXE _setup\_tools\bsdiff\patch\MAXHELP.EXE.patch
	del 2knet\MAXHELP.EXE.old
goto :eof

:: .......................................................................................

:: 2knetdem.zip / SETUP2K.EXE
:i_1
if exist "%TEMP%.\Temporary Directory 0 for 2knetdem.zip\*" rmdir /s /q "%TEMP%.\Temporary Directory 0 for 2knetdem.zip"
if exist "%TEMP%.\Temporary Directory 0 for 2knetdem.zip" del /f "%TEMP%.\Temporary Directory 0 for 2knetdem.zip"
mkdir "%TEMP%.\Temporary Directory 0 for 2knetdem.zip"
if not exist "%TEMP%.\Temporary Directory 0 for 2knetdem.zip\*" goto e_1
echo Downloading, please wait . . .
cscript.exe //nologo //e:jscript "%~1" "http://pds.gajai.com/dn.php?no=11859&path=199701/06/&savedf=85247640000024456.zip&rsavedf=2knetdem.zip" "2knetdem.zip"
copy /y "%TEMP%.\Temporary Directory 0 for 2knetdem.zip\SETUP2K.EXE" "_setup\SETUP2K.EXE"
for /f "tokens=*" %%A in ('^"dir "%TEMP%.\Temporary Directory * for 2knetdem.zip" /a:d /b^"') do rmdir /s /q "%TEMP%.\%%~A"
if not exist "_setup\SETUP2K.EXE" goto e_1
goto :eof
:e_1
	echo;
	echo Error downloading 2knetdem.zip
	echo;
	echo Retry? [y/n]
	set]=y&set/p]=&set]|find/i"]=y">nul
	if not errorlevel 1 goto i_1
goto :eof

:: Update2KNet11.exe
:i_2
if exist "%TEMP%.\Temporary Directory 0 for Update2KNet11.exe\*" rmdir /s /q "%TEMP%.\Temporary Directory 0 for Update2KNet11.exe"
if exist "%TEMP%.\Temporary Directory 0 for Update2KNet11.exe" del /f "%TEMP%.\Temporary Directory 0 for Update2KNet11.exe"
mkdir "%TEMP%.\Temporary Directory 0 for Update2KNet11.exe"
if not exist "%TEMP%.\Temporary Directory 0 for Update2KNet11.exe\*" goto e_2
echo Downloading, please wait . . .
cscript.exe //nologo //e:jscript "%~1" "http://ftp.games.skynet.be/pub/ftp.ea.com/maxis/patches/SC2000%%20Network/update2knet11.exe" "Update2KNet11.exe"
copy /y "%TEMP%.\Temporary Directory 0 for Update2KNet11.exe\Update2KNet11.exe" "_setup\Update2KNet11.exe"
for /f "tokens=*" %%A in ('^"dir "%TEMP%.\Temporary Directory * for Update2KNet11.exe" /a:d /b^"') do rmdir /s /q "%TEMP%.\%%~A"
if not exist "_setup\Update2KNet11.exe" goto e_2
goto :eof
:e_2
	echo;
	echo Error downloading Update2KNet11.exe
	echo;
	echo Retry? [y/n]
	set]=y&set/p]=&set]|find/i"]=y">nul
	if not errorlevel 1 goto i_2
goto :eof

:: .......................................................................................

:brk
echo;
echo Press any key to abort and exit . . .
pause > nul
exit

:loc
echo;
echo The setup script must be run from a non-networked, non-root directory
echo Try a folder on your desktop or a subfolder of your documents folder
goto end

:err
echo;
echo Critical files missing
echo Re-unzip the setup script and folder then try again
:: goto end

:end
echo;
echo Press any key to exit . . .
pause > nul
if defined ^" cls
goto :eof

:: .......................................................................................
*/
if (WScript.Arguments.Length == 2)
if (WScript.Arguments.Item(0).length >= 1)
if (WScript.Arguments.Item(1).length >= 1)
fMain();

function fMain()
{
	var oShell = WScript.CreateObject("WScript.Shell");
	var evTEMP = oShell.ExpandEnvironmentStrings("%TEMP%");
	if (evTEMP != "%TEMP%")
	{
		evTEMP += ".\\Temporary Directory 0 for " + WScript.Arguments.Item(1);
		var oXMLHTTP = new ActiveXObject("MSXML2.XMLHTTP");
		oXMLHTTP.open("GET", WScript.Arguments.Item(0), false);
		oXMLHTTP.send();
		if (oXMLHTTP.status == 200)
		{
			var oStream = new ActiveXObject("ADODB.Stream");
			oStream.Type = 1;
			oStream.Open();
			oStream.Write(oXMLHTTP.responseBody);
			oStream.SaveToFile(evTEMP + "\\" + WScript.Arguments.Item(1), 2);
			oStream.Close();
			if (WScript.Arguments.Item(1).split(".").pop().toLowerCase() == "zip")
			{
				var oUnzip = new ActiveXObject("Shell.Application");
				oUnzip.NameSpace(evTEMP).CopyHere(oUnzip.NameSpace(evTEMP + "\\" + WScript.Arguments.Item(1)).Items());
			}
		}
	}
}

/*
:eof */
